#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#define Max   1024
#define fail  0
#define null  0
#define true  1
#define false 0

#define msg_size      4        /* integer */
#define Rankmax       2
#define Bufmax        1024
#define Nmax          1024     /* Maximum global domain size  */
#define Procmax       32       /* Maximum number of processor on each dim*/

int    my_pnum;            /* The ID of the Processor */
int    my_id;              /* The ID of the selected dim in the converted ID */
int    ori_nproc;          /* Number of available  processors */
int    tot_nproc;          /* Total number of processors */
int    tot_dproc;          /* dimension of tot_nproc */
int    direction;          /* the direction to communicate */
int    dir_nproc;          /* Totol number of processors in the selected dim */
int     rank;               /* rank */

int    v_size; /* Vector Size */
int    digit;  /* binary digit */
int    in_mesg[Max];   /* received data */
int    Vector[Max];    /* original data */
int    Original[Max];  /* result data */
int    Right[Max][Max];   /* Sums from right child process by step.
				  1st dimension is for step, and
				  2nd dimension is for the sums
				  from the right child process.          */
int    Sum[Max];     /* Sum from parent process */

int    my_grid[Rankmax];    /* converted ID */
int    nproc[Rankmax];     /* Total number of processors on each dims */
int    dproc[Rankmax];     /* Total dimension of processors */




/*******************************************************************************
 *   Procedure : Ilog2()                                                       *
 *   Input     : int n                                                         *
 *   Output    : log2(n)                                                       *
 *   Function  : return the integer value of log2(n) if it is integer.         *
 *               If not, return -1.                                            *
 *******************************************************************************/
int Ilog2(n)
     int n;
{
  int i = 0;
  int n1 = n;

  if ( n < 1 ) return -1;

  while ( n1 >>= 1 )
    ++i;

  if ( 1 << i != n )
    return -1;
  else
    return i;
}

/*******************************************************************************
 *   Procedure : map_to_pnum                                                   *
 *   Input     :                                                               *
 *   Output    :                                                               *
 *   Function  :                                                               *
 *******************************************************************************/
map_to_pnum(grid, pn)    /* grid to 1-d array */
     int grid[Rankmax];      
     int *pn;
{
  int i, mult=1;

  *pn = 0;

  for (i=0; i<rank; ++i) {
    *pn += grid[i] * mult;
    mult *= nproc[i];
  }

}

/*******************************************************************************
 *   Procedure : map_to_grid                                                   *
 *   Input     :                                                               *
 *   Output    :                                                               *
 *   Function  :                                                               *
 *******************************************************************************/
map_to_grid(pn, grid)   /* 1-D array to grid */
     int pn;
     int grid[Rankmax];
{
  int i, mult, mod;

  mult  = tot_nproc;
  mod = pn;

  for (i=rank-1; i>=0; --i) {
    mult /= nproc[i];
    grid[i] = mod / mult;
    mod %= mult;
  }

}


main() {

   int error;
   int i, j,k;
   int total = 1, t_total=1;
   int save;


   /*---------------- Rank of the input Array ---------------------------*/
   do {
      printf("\nEnter rank of the input array (Max=%d): ", Rankmax);
      scanf("%d", &rank);
      error = ( rank < 1 || rank > Rankmax );
      if (error)
	 printf("\n??? Improper rank. Try again!\n");
    } while (error);

   printf("\nEnter direction to communicate (0 ~ %d): ", rank-1);
   scanf("%d", &direction);

   printf("\nEnter vector size : ");
   scanf("%d", &v_size);

   /*-------------------- from dim=0 to dim=rank-1 ----------------------*/
   for (i=0; i<rank; ++i) {

     /*------------ Source Distribution for A, M ------------------*/
     save = total;
     do {
       printf("\n   Enter number of source processors (Max=%d): ", 
	      Procmax/total);
       scanf("%d", &nproc[i]);
       total *= nproc[i];

       dproc[i] = Ilog2(nproc[i]);

     } while (error);
   }

   tot_nproc = total;

   for ( i = 0 ; i < tot_nproc ; i++ ) {
     map_to_grid(i, my_grid);
     printf("%d  =>", i);
     for ( j = 0 ; j < rank ; j++ ) {
       printf("%d ", my_grid[j]);
     }


     map_to_pnum(my_grid, &k);
     printf("%d \n", k);
   }
 }
